Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -412,69 +594,88 @@
     # get group name that we're looking for
     my $foundMatch = 0;
-    my ($ifdName, $mieGroup);
-    if ($wantGroup) {
-        # set $ifdName if this group is a valid IFD or SubIFD name
-        if ($wantGroup =~ /^IFD(\d+)$/i) {
-            $ifdName = "IFD$1";
-        } elsif ($wantGroup =~ /^SubIFD(\d+)$/i) {
-            $ifdName = "SubIFD$1";
-        } elsif ($wantGroup =~ /^Version(\d+)$/i) {
-            $ifdName = "Version$1"; # Sony IDC VersionIFD
-        } elsif ($wantGroup =~ /^MIE(\d*-?)(\w+)$/i) {
-            $mieGroup = "MIE$1" . ucfirst(lc($2));
-        } else {
-            $ifdName = $exifDirs{lc($wantGroup)};
-            if (not $ifdName and $wantGroup =~ /^XMP\b/i) {
-                # must load XMP table to set group1 names
-                my $table = GetTagTable('Image::ExifTool::XMP::Main');
-                my $writeProc = $table->{WRITE_PROC};
-                $writeProc and &$writeProc();
-            }
-        }
-    }
 #
 # determine the groups for all tags found, and the tag with
 # the highest priority group
 #
-    my (@tagInfoList, @writeAlsoList, %writeGroup, %preferred, %tagPriority, $avoid, $wasProtected);
-    my $highestPriority = -1;
-    foreach $tagInfo (@matchingTags) {
-        $tag = $tagInfo->{Name};    # set tag so warnings will use proper case
-        my ($writeGroup, $priority);
+    my (@tagInfoList, @writeAlsoList, %writeGroup, %preferred, %tagPriority);
+    my (%avoid, $wasProtected, $noCreate, %highestPriority, %highestQT);
+
+TAG: foreach $tagInfo (@matchingTags) {
+        $tag = $$tagInfo{Name};     # get tag name for warnings
+        my $lcTag = lc $tag;        # get lower-case tag name for use in variables
+        # initialize highest priority if we are starting a new tag
+        $highestPriority{$lcTag} = -999 unless defined $highestPriority{$lcTag};
+        my ($priority, $writeGroup);
+        my $prfTag = defined $$tagInfo{Preferred} ? $$tagInfo{Preferred} : $$tagInfo{Table}{PREFERRED};
         if ($wantGroup) {
-            my $lcWant = lc($wantGroup);
-            # only set tag in specified group
-            $writeGroup = $self->GetGroup($tagInfo, 0);
-            unless (lc($writeGroup) eq $lcWant) {
-                if ($writeGroup eq 'EXIF' or $writeGroup eq 'SonyIDC') {
-                    next unless $ifdName;
-                    # can't yet write PreviewIFD tags
-                    $ifdName eq 'PreviewIFD' and ++$foundMatch, next;
-                    $writeGroup = $ifdName;  # write to the specified IFD
-                } elsif ($writeGroup eq 'MIE') {
-                    next unless $mieGroup;
+            # a WriteGroup of All is special
+            my $wgAll = ($$tagInfo{WriteGroup} and $$tagInfo{WriteGroup} eq 'All');
+            my @grp = $self->GetGroup($tagInfo);
+            my $hiPri = 1000;
+            foreach $fg (@wantGroup) {
+                my ($fam, $lcWant) = @$fg;
+                $lcWant = $translateWantGroup{$lcWant} if $translateWantGroup{$lcWant};
+                # only set tag in specified group
+                # bump priority of preferred tag
+                $hiPri += $prfTag if $prfTag;
+                if (not defined $fam) {
+                    if ($lcWant eq lc $grp[0]) {
+                        # don't go to more general write group of "All"
+                        # if something more specific was wanted
+                        $writeGroup = $grp[0] if $wgAll and not $writeGroup;
+                        next;
+                    }
+                    next if $lcWant eq lc $grp[2];
+                } elsif ($fam == 7) {
+                    next if IsSameID($$tagInfo{TagID}, $lcWant);
+                } elsif ($fam != 1 and not $$tagInfo{AllowGroup}) {
+                    next if $lcWant eq lc $grp[$fam];
+                    if ($wgAll and not $fam and $allFam0{$lcWant}) {
+                        $writeGroup or $writeGroup = $allFam0{$lcWant};
+                        next;
+                    }
+                    next TAG;   # wrong group
+                }
+                # handle family 1 groups specially
+                if ($grp[0] eq 'EXIF' or $grp[0] eq 'SonyIDC' or $wgAll) {
+                    unless ($ifdName and $lcWant eq lc $ifdName) {
+                        next TAG unless $wgAll and not $fam and $allFam0{$lcWant};
+                        $writeGroup = $allFam0{$lcWant} unless $writeGroup;
+                        next;
+                    }
+                    next TAG if $wgAll and $allFam0{$lcWant} and $fam;
+                    # can't yet write PreviewIFD tags (except for image)
+                    $lcWant eq 'PreviewIFD' and ++$foundMatch, next TAG;
+                    $writeGroup = $ifdName; # write to the specified IFD
+                } elsif ($grp[0] eq 'QuickTime') {
+                    if ($grp[1] eq 'Track#') {
+                        next TAG unless $movGroup and $lcWant eq lc($movGroup);
+                        $writeGroup = $movGroup;
+                    } else {
+                        my $grp = $$tagInfo{Table}{WRITE_GROUP};
+                        next TAG unless $grp and $lcWant eq lc $grp;
+                        $writeGroup = $grp;
+                    }
+                } elsif ($grp[0] eq 'MIE') {
+                    next TAG unless $mieGroup and $lcWant eq lc($mieGroup);
                     $writeGroup = $mieGroup; # write to specific MIE group
                     # set specific write group with document number if specified
-                    if ($writeGroup =~ /^MIE\d+$/ and $tagInfo->{Table}{WRITE_GROUP}) {
-                        $writeGroup = $tagInfo->{Table}{WRITE_GROUP};
+                    if ($writeGroup =~ /^MIE\d+$/ and $$tagInfo{Table}{WRITE_GROUP}) {
+                        $writeGroup = $$tagInfo{Table}{WRITE_GROUP};
                         $writeGroup =~ s/^MIE/$mieGroup/;
                     }
-                } elsif (not $$tagInfo{AllowGroup} or $wantGroup !~ /^$$tagInfo{AllowGroup}$/i) {
+                } elsif (not $$tagInfo{AllowGroup} or $lcWant !~ /^$$tagInfo{AllowGroup}$/i) {
                     # allow group1 name to be specified
-                    my $grp1 = $self->GetGroup($tagInfo, 1);
-                    unless ($grp1 and lc($grp1) eq $lcWant) {
-                        # must also check group1 name directly in case it is different
-                        $grp1 = $tagInfo->{Groups}{1};
-                        next unless $grp1 and lc($grp1) eq $lcWant;
-                    }
-                }
-            }
-            $priority = 1000;   # highest priority since group was specified
+                    next TAG unless $lcWant eq lc $grp[1];
+                }
+            }
+            $writeGroup or $writeGroup = ($$tagInfo{WriteGroup} || $$tagInfo{Table}{WRITE_GROUP} || $grp[0]);
+            $priority = $hiPri; # highest priority since group was specified
         }
         ++$foundMatch;
         # must do a dummy call to the write proc to autoload write package
         # before checking Writable flag
-        my $table = $tagInfo->{Table};
-        my $writeProc = $table->{WRITE_PROC};
+        my $table = $$tagInfo{Table};
+        my $writeProc = $$table{WRITE_PROC};
         # load source table if this was a user-defined table
         if ($$table{SRC_TABLE}) {
@@ -482,13 +683,18 @@
             $writeProc = $$src{WRITE_PROC} unless $writeProc;
         }
-        next unless $writeProc and &$writeProc();
+        {
+            no strict 'refs';
+            next unless $writeProc and &$writeProc();
+        }
         # must still check writable flags in case of UserDefined tags
-        my $writable = $tagInfo->{Writable};
-        next unless $writable or ($table->{WRITABLE} and
+        my $writable = $$tagInfo{Writable};
+        next unless $writable or ($$table{WRITABLE} and
             not defined $writable and not $$tagInfo{SubDirectory});
         # set specific write group (if we didn't already)
-        if (not $writeGroup or $translateWriteGroup{$writeGroup}) {
+        if (not $writeGroup or ($translateWriteGroup{$writeGroup} and
+            (not $$tagInfo{WriteGroup} or $$tagInfo{WriteGroup} ne 'All')))
+        {
             # use default write group
-            $writeGroup = $tagInfo->{WriteGroup} || $tagInfo->{Table}{WRITE_GROUP};
+            $writeGroup = $$tagInfo{WriteGroup} || $$tagInfo{Table}{WRITE_GROUP};
             # use group 0 name if no WriteGroup specified
             my $group0 = $self->GetGroup($tagInfo, 0);
@@ -496,13 +702,17 @@
             # get priority for this group
             unless ($priority) {
-                $priority = $self->{WRITE_PRIORITY}{lc($writeGroup)};
+                $priority = $$self{WRITE_PRIORITY}{lc($writeGroup)};
                 unless ($priority) {
-                    $priority = $self->{WRITE_PRIORITY}{lc($group0)} || 0;
-                }
-            }
+                    $priority = $$self{WRITE_PRIORITY}{lc($group0)} || 0;
+                }
+            }
+            # adjust priority based on Preferred level for this tag
+            $priority += $prfTag if $prfTag;
         }
         # don't write tag if protected
-        if ($tagInfo->{Protected}) {
-            my $prot = $tagInfo->{Protected} & ~$protected;
+        my $prot = $$tagInfo{Protected};
+        $prot = 1 if $noFlat and defined $$tagInfo{Flat};
+        if ($prot) {
+            $prot &= ~$protected;
             if ($prot) {
                 my %lkup = ( 1=>'unsafe', 2=>'protected', 3=>'unsafe and protected');
@@ -510,5 +720,5 @@
                 if ($verbose > 1) {
                     my $wgrp1 = $self->GetWriteGroup1($tagInfo, $writeGroup);
-                    print $out "Not writing $wgrp1:$tag ($wasProtected)\n";
+                    print $out "Sorry, $wgrp1:$tag is $wasProtected for writing\n";
                 }
                 next;
@@ -517,13 +727,15 @@
         # set priority for this tag
         $tagPriority{$tagInfo} = $priority;
-        if ($priority > $highestPriority) {
-            $highestPriority = $priority;
-            %preferred = ( $tagInfo => 1 );
-            $avoid = 0;
-            ++$avoid if $$tagInfo{Avoid};
-        } elsif ($priority == $highestPriority) {
+        # keep track of highest priority QuickTime tag
+        $highestQT{$lcTag} = $priority if $$table{GROUPS}{0} eq 'QuickTime' and
+            (not defined $highestQT{$lcTag} or $highestQT{$lcTag} < $priority);
+        if ($priority > $highestPriority{$lcTag}) {
+            $highestPriority{$lcTag} = $priority;
+            $preferred{$lcTag} = { $tagInfo => 1 };
+            $avoid{$lcTag} = $$tagInfo{Avoid} ? 1 : 0;
+        } elsif ($priority == $highestPriority{$lcTag}) {
             # create all tags with highest priority
-            $preferred{$tagInfo} = 1;
-            ++$avoid if $$tagInfo{Avoid};
+            $preferred{$lcTag}{$tagInfo} = 1;
+            ++$avoid{$lcTag} if $$tagInfo{Avoid};
         }
         if ($$tagInfo{WriteAlso}) {
@@ -533,7 +745,12 @@
             push @tagInfoList, $tagInfo;
         }
+        # special case to allow override of XMP WriteGroup
+        if ($writeGroup eq 'XMP') {
+            my $wg = $$tagInfo{WriteGroup} || $$table{WRITE_GROUP};
+            $writeGroup = $wg if $wg;
+        }
         $writeGroup{$tagInfo} = $writeGroup;
     }
-    # sort tag info list in reverse order of priority (higest number last)
+    # sort tag info list in reverse order of priority (highest number last)
     # so we get the highest priority error message in the end
     @tagInfoList = sort { $tagPriority{$a} <=> $tagPriority{$b} } @tagInfoList;
@@ -541,36 +758,46 @@
     unshift @tagInfoList, @writeAlsoList if @writeAlsoList;
 
-    # don't create tags with priority 0 if group priorities are set
-    if ($highestPriority == 0 and %{$self->{WRITE_PRIORITY}}) {
-        undef %preferred;
-    }
-    # avoid creating tags with 'Avoid' flag set if there are other alternatives
-    if ($avoid and %preferred) {
-        if ($avoid < scalar(keys %preferred)) {
-            # just remove the 'Avoid' tags since there are other preferred tags
-            foreach $tagInfo (@tagInfoList) {
-                delete $preferred{$tagInfo} if $$tagInfo{Avoid};
-            }
-        } elsif ($highestPriority < 1000) {
-            # look for another priority tag to create instead
-            my $nextHighest = 0;
-            my @nextBestTags;
-            foreach $tagInfo (@tagInfoList) {
-                my $priority = $tagPriority{$tagInfo} or next;
-                next if $priority == $highestPriority;
-                next if $priority < $nextHighest;
-                next if $$tagInfo{Avoid} or $$tagInfo{Permanent};
-                next if $writeGroup{$tagInfo} eq 'MakerNotes';
-                if ($nextHighest < $priority) {
-                    $nextHighest = $priority;
-                    undef @nextBestTags;
-                }
-                push @nextBestTags, $tagInfo;
-            }
-            if (@nextBestTags) {
-                # change our preferred tags to the next best tags
-                undef %preferred;
-                foreach $tagInfo (@nextBestTags) {
-                    $preferred{$tagInfo} = 1;
+    # check priorities for each set of tags we are writing
+    my $lcTag;
+    foreach $lcTag (keys %preferred) {
+        # don't create tags with priority 0 if group priorities are set
+        if ($preferred{$lcTag} and $highestPriority{$lcTag} == 0 and
+            %{$$self{WRITE_PRIORITY}})
+        {
+            delete $preferred{$lcTag}
+        }
+        # avoid creating tags with 'Avoid' flag set if there are other alternatives
+        if ($avoid{$lcTag} and $preferred{$lcTag}) {
+            if ($avoid{$lcTag} < scalar(keys %{$preferred{$lcTag}})) {
+                # just remove the 'Avoid' tags since there are other preferred tags
+                foreach $tagInfo (@tagInfoList) {
+                    next unless $lcTag eq lc $$tagInfo{Name};
+                    delete $preferred{$lcTag}{$tagInfo} if $$tagInfo{Avoid};
+                }
+            } elsif ($highestPriority{$lcTag} < 1000) {
+                # look for another priority tag to create instead
+                my $nextHighest = 0;
+                my @nextBestTags;
+                foreach $tagInfo (@tagInfoList) {
+                    next unless $lcTag eq lc $$tagInfo{Name};
+                    my $priority = $tagPriority{$tagInfo} or next;
+                    next if $priority == $highestPriority{$lcTag};
+                    next if $priority < $nextHighest;
+                    my $permanent = $$tagInfo{Permanent};
+                    $permanent = $$tagInfo{Table}{PERMANENT} unless defined $permanent;
+                    next if $$tagInfo{Avoid} or $permanent;
+                    next if $writeGroup{$tagInfo} eq 'MakerNotes';
+                    if ($nextHighest < $priority) {
+                        $nextHighest = $priority;
+                        undef @nextBestTags;
+                    }
+                    push @nextBestTags, $tagInfo;
+                }
+                if (@nextBestTags) {
+                    # change our preferred tags to the next best tags
+                    delete $preferred{$lcTag};
+                    foreach $tagInfo (@nextBestTags) {
+                        $preferred{$lcTag}{$tagInfo} = 1;
+                    }
                 }
             }
@@ -592,15 +819,25 @@
         my $writeGroup = $writeGroup{$tagInfo};
         my $permanent = $$tagInfo{Permanent};
+        $permanent = $$tagInfo{Table}{PERMANENT} unless defined $permanent;
         $writeGroup eq 'MakerNotes' and $permanent = 1 unless defined $permanent;
         my $wgrp1 = $self->GetWriteGroup1($tagInfo, $writeGroup);
-        $tag = $tagInfo->{Name};    # get proper case for tag name
+        $tag = $$tagInfo{Name};     # get tag name for warnings
+        my $lcTag = lc $tag;
+        my $pref = $preferred{$lcTag} || { };
         my $shift = $options{Shift};
+        my $addValue = $options{AddValue};
         if (defined $shift) {
-            # (can't currently shift List-type tags)
-            if ($tagInfo->{Shift} and not $tagInfo->{List}) {
+            # (can't currently shift list-type tags)
+            my $shiftable;
+            if ($$tagInfo{List}) {
+                $shiftable = '';    # can add/delete but not shift
+            } else {
+                $shiftable = $$tagInfo{Shift};
                 unless ($shift) {
                     # set shift according to AddValue/DelValue
-                    $shift = 1 if $options{AddValue};
-                    $shift = -1 if $options{DelValue};
+                    $shift = 1 if $addValue;
+                    # can shift a date/time with -=, but this is
+                    # a conditional delete operation for other tags
+                    $shift = -1 if $options{DelValue} and defined $shiftable and $shiftable eq 'Time';
                 }
                 if ($shift and (not defined $value or not length $value)) {
@@ -611,5 +848,10 @@
                     undef $shift;
                 }
-            } elsif ($shift) {
+            }
+                # can't shift List-type tag
+            if ((defined $shiftable and not $shiftable) and
+                # and don't try to conditionally delete if Shift is "0"
+                ($shift or ($shiftable eq '0' and $options{DelValue})))
+            {
                 $err = "$wgrp1:$tag is not shiftable";
                 $verbose > 2 and print $out "$err\n";
@@ -620,17 +862,29 @@
         if (defined $val) {
             # check to make sure this is a List or Shift tag if adding
-            if ($options{AddValue} and not ($shift or $tagInfo->{List})) {
-                $err = "Can't add $wgrp1:$tag (not a List type)";
-                $verbose > 2 and print $out "$err\n";
-                next;
+            if ($addValue and not ($shift or $$tagInfo{List})) {
+                if ($addValue eq '2') {
+                    undef $addValue;    # quietly reset this option
+                } else {
+                    $err = "Can't add $wgrp1:$tag (not a List type)";
+                    $verbose > 2 and print $out "$err\n";
+                    next;
+                }
             }
             if ($shift) {
-                # add '+' or '-' prefix to indicate shift direction
-                $val = ($shift > 0 ? '+' : '-') . $val;
-                # check the shift for validity
-                require 'Image/ExifTool/Shift.pl';
-                my $err2 = CheckShift($tagInfo->{Shift}, $val);
-                if ($err2) {
-                    $err = "$err2 for $wgrp1:$tag";
+                if ($$tagInfo{Shift} and $$tagInfo{Shift} eq 'Time') {
+                    # add '+' or '-' prefix to indicate shift direction
+                    $val = ($shift > 0 ? '+' : '-') . $val;
+                    # check the shift for validity
+                    require 'Image/ExifTool/Shift.pl';
+                    my $err2 = CheckShift($$tagInfo{Shift}, $val);
+                    if ($err2) {
+                        $err = "$err2 for $wgrp1:$tag";
+                        $verbose > 2 and print $out "$err\n";
+                        next;
+                    }
+                } elsif (IsFloat($val)) {
+                    $val *= $shift;
+                } else {
+                    $err = "Shift value for $wgrp1:$tag is not a number";
                     $verbose > 2 and print $out "$err\n";
                     next;
@@ -645,4 +899,5 @@
             }
         } elsif ($permanent) {
+            return 0 if $options{IgnorePermanent};
             # can't delete permanent tags, so set them to DelValue or empty string instead
             if (defined $$tagInfo{DelValue}) {
@@ -652,22 +907,35 @@
                 $val = '';
             }
-        } elsif ($options{AddValue} or $options{DelValue}) {
+        } elsif ($addValue or $options{DelValue}) {
             $err = "No value to add or delete in $wgrp1:$tag";
             $verbose > 2 and print $out "$err\n";
             next;
         } else {
-            if ($tagInfo->{DelCheck}) {
+            if ($$tagInfo{DelCheck}) {
                 #### eval DelCheck ($self, $tagInfo, $wantGroup)
-                my $err2 = eval $tagInfo->{DelCheck};
+                my $err2 = eval $$tagInfo{DelCheck};
                 $@ and warn($@), $err2 = 'Error evaluating DelCheck';
-                if ($err2) {
+                if (defined $err2) {
+                    # (allow other tags to be set using DelCheck as a hook)
+                    $err2 or goto WriteAlso; # GOTO!
                     $err2 .= ' for' unless $err2 =~ /delete$/;
                     $err = "$err2 $wgrp1:$tag";
                     $verbose > 2 and print $out "$err\n";
                     next;
-                } elsif (defined $err2) {
-                    ++$numSet;  # (allow other tags to be set using DelCheck as a hook)
-                    goto WriteAlso;
-                }
+                }
+            }
+            # set group delete flag if this tag represents an entire group
+            if ($$tagInfo{DelGroup} and not $options{DelValue}) {
+                my @del = ( $tag );
+                $$self{DEL_GROUP}{$tag} = 1;
+                # delete extra groups if necessary
+                if ($delMore{$tag}) {
+                    $$self{DEL_GROUP}{$_} = 1, push(@del,$_) foreach @{$delMore{$tag}};
+                }
+                # remove all of this group from previous new values
+                $self->RemoveNewValuesForGroup($tag);
+                $verbose and print $out "  Deleting tags in: @del\n";
+                ++$numSet;
+                next;
             }
             $noConv = 1;    # value is not defined, so don't do conversion
@@ -677,13 +945,11 @@
         unless ($noConv) {
             # set default conversion type used by ConvInv() and CHECK_PROC routines
-            $$self{ConvType} = $options{Type} || ($self->{OPTIONS}{PrintConv} ? 'PrintConv' : 'ValueConv');
+            $$self{ConvType} = $convType;
             my $e;
-            ($val,$e) = $self->ConvInv($val, $tagInfo, $tag, $wgrp1, $$self{ConvType}, $wantGroup);
+            ($val,$e) = $self->ConvInv($val,$tagInfo,$tag,$wgrp1,$$self{ConvType},$wantGroup);
             if (defined $e) {
-                if ($e) {
-                    ($err = $e) =~ s/\$wgrp1/$wgrp1/g;
-                } else {
-                    ++$numSet;  # an empty error string causes error to be ignored
-                }
+                # empty error string causes error to be ignored without setting the value
+                $e or goto WriteAlso; # GOTO!
+                $err = $e;
             }
         }
@@ -694,13 +960,18 @@
             $val = 'xxx never delete xxx';
         }
-        $self->{NEW_VALUE} or $self->{NEW_VALUE} = { };
+        $$self{NEW_VALUE} or $$self{NEW_VALUE} = { };
         if ($options{Replace}) {
             # delete the previous new value
-            $self->GetNewValueHash($tagInfo, $writeGroup, 'delete');
+            $self->GetNewValueHash($tagInfo, $writeGroup, 'delete', $options{ProtectSaved});
             # also delete related tag previous new values
             if ($$tagInfo{WriteAlso}) {
-                my $wtag;
+                my ($wgrp, $wtag);
+                if ($$tagInfo{WriteGroup} and $$tagInfo{WriteGroup} eq 'All' and $writeGroup) {
+                    $wgrp = $writeGroup . ':';
+                } else {
+                    $wgrp = '';
+                }
                 foreach $wtag (keys %{$$tagInfo{WriteAlso}}) {
-                    my ($n,$e) = $self->SetNewValue($wtag, undef, Replace=>2);
+                    my ($n,$e) = $self->SetNewValue($wgrp . $wtag, undef, Replace=>2);
                     $numSet += $n;
                 }
@@ -711,24 +982,33 @@
         if (defined $val) {
             # we are editing this tag, so create a NEW_VALUE hash entry
-            my $nvHash = $self->GetNewValueHash($tagInfo, $writeGroup, 'create');
-            $nvHash->{WantGroup} = $wantGroup;
+            my $nvHash = $self->GetNewValueHash($tagInfo, $writeGroup, 'create',
+                                $options{ProtectSaved}, ($options{DelValue} and not $shift));
+            # ignore new values protected with ProtectSaved
+            $nvHash or ++$numSet, next; # (increment $numSet to avoid warning)
+            $$nvHash{NoReplace} = 1 if $$tagInfo{List} and not $options{Replace};
+            $$nvHash{WantGroup} = $wantGroup;
+            $$nvHash{EditOnly} = 1 if $editOnly;
             # save maker note information if writing maker notes
             if ($$tagInfo{MakerNotes}) {
-                $nvHash->{MAKER_NOTE_FIXUP} = $self->{MAKER_NOTE_FIXUP};
-            }
-            if ($options{DelValue} or $options{AddValue} or $shift) {
+                $$nvHash{MAKER_NOTE_FIXUP} = $$self{MAKER_NOTE_FIXUP};
+            }
+            if ($createOnly) {  # create only (never edit)
+                # empty item in DelValue list to never edit existing value
+                $$nvHash{DelValue} = [ '' ];
+                $$nvHash{CreateOnly} = 1;
+            } elsif ($options{DelValue} or $addValue or $shift) {
                 # flag any AddValue or DelValue by creating the DelValue list
-                $nvHash->{DelValue} or $nvHash->{DelValue} = [ ];
+                $$nvHash{DelValue} or $$nvHash{DelValue} = [ ];
                 if ($shift) {
                     # add shift value to list
-                    $nvHash->{Shift} = $val;
+                    $$nvHash{Shift} = $val;
                 } elsif ($options{DelValue}) {
                     # don't create if we are replacing a specific value
-                    $nvHash->{IsCreating} = 0 unless $val eq '' or $tagInfo->{List};
+                    $$nvHash{IsCreating} = 0 unless $val eq '' or $$tagInfo{List};
                     # add delete value to list
-                    push @{$nvHash->{DelValue}}, ref $val eq 'ARRAY' ? @$val : $val;
+                    push @{$$nvHash{DelValue}}, ref $val eq 'ARRAY' ? @$val : $val;
                     if ($verbose > 1) {
                         my $verb = $permanent ? 'Replacing' : 'Deleting';
-                        my $fromList = $tagInfo->{List} ? ' from list' : '';
+                        my $fromList = $$tagInfo{List} ? ' from list' : '';
                         my @vals = (ref $val eq 'ARRAY' ? @$val : $val);
                         foreach (@vals) {
@@ -737,5 +1017,5 @@
                                 $_ = Image::ExifTool::XMP::SerializeStruct($_);
                             }
-                            print $out "$verb $wgrp1:$tag$fromList if value is '$_'\n";
+                            print $out "$verb $wgrp1:$tag$fromList if value is '${_}'\n";
                         }
                     }
